#include<iostream>
using namespace std;
void daj_krv(char krv[][3],int i,int kolicina[],int zaliha[4],int a[][4],int k)
{
    if(krv[i][0]=='O')
    {
        zaliha[0]-=kolicina[i];
        if(zaliha[0]<0)
        {
            k=0;
            return;

        }
        a[i][0]=kolicina[i];

    }
    else if(krv[i][0]=='A'&&krv[i][1]=='\0')
    {
        if(zaliha[1]>=kolicina[i])
        {
            zaliha[1]-=kolicina[i];

        }
        else
        {
            a[i][1]=zaliha[1];
            kolicina[i]-=zaliha[1];
            zaliha[1]=0;
            zaliha[0]-=kolicina[i];
            if(zaliha[0]<0)
            {
                k=0;
                return;
            }

        }
        a[i][0]=kolicina[i];
    }
    else if(krv[i][0]=='B')
    {
        if(zaliha[2]>=kolicina[i])
            {
                zaliha[2]-=kolicina[i];

            }
            else
            {
            a[i][2]=zaliha[2];
            kolicina[i]-=zaliha[2];
            zaliha[2]=0;
            zaliha[0]-=kolicina[i];
            if(zaliha[0]<0)
            {
                k=0;
                return;
            }

        }
        a[i][0]=kolicina[i];
    }
    else
    {

    }
}
int main()
{
    int n,k=1,i,j;
    cin>>n;
    int zaliha[4],kolicina[n];

    cin>>zaliha[0]>>zaliha[1]>>zaliha[2]>>zaliha[3];
    char krv[n][3];
    for(i=0;i<n;i++)
        cin>>krv[i][3]>>kolicina[n];
    int a[n][4];
    for(i=0;i<n;i++)
        for(j=0;j<4;j++)
            a[i][j]=0;
    cout<<krv;
    for(i=0;i<n&&k!=0;i++)
        daj_krv(krv,i,kolicina,zaliha,a,k);
    if(k==0)
    {
        cout<<"nemoguce";
        return 0;
    }

}